(* Time-stamp: <modified the 21/02/2014 (at 18:08) by Erwan Jahier> *)

(* generate ocaml glue code that makes it possible to call lus2lic
   from ocaml with the current set of arguments (with Lus2licRun.make).
*)
let (f: string array -> Lv6MainArgs.t -> unit) =
  fun argv opt -> 
    let outfile = if opt.outfile <> "" then opt.outfile else
        let file = List.hd opt.infiles in
        try (Filename.chop_extension (Filename.basename file))^ ".ml"
        with _ -> 
		    print_string ("*** '"^file^"': bad file name.\n"); exit 2
    in
    let cma_file = (Filename.chop_extension outfile) ^".cma" in
    let remove_me = ["-exec"; "-ocaml";"-o";opt.outfile] in
    let args = 
      Array.fold_right (fun x acc -> if List.mem x remove_me then acc else x::acc) argv []
    in
    let args_str = "\"" ^ (String.concat "\";\"" args) ^"\"" in
    let oc = open_out (outfile)  in
    Lv6util.dump_entete oc;
    Printf.fprintf oc "
let inputs, outputs, kill, step, step_dbg, mems_i,mems_o = 
  let args = Array.of_list [%s] in
  Lus2licRun.make args

let dyn_file = (Dynlink.adapt_filename \"%s\")
let _ = 
  OcamlRM.reg_inputs dyn_file inputs;
  OcamlRM.reg_outputs dyn_file outputs;
  OcamlRM.reg_kill dyn_file kill;
  OcamlRM.reg_step dyn_file step;
  OcamlRM.reg_step_dbg dyn_file step_dbg;
  OcamlRM.reg_mems dyn_file mems_i mems_o
" args_str cma_file
