
type enum_mode = 
    AsInt  (* translate enums into int (for rif-friendlyness *)
  | AsConst  (* translate enums into abstract const *)
  | AsEnum (* do nothing *)


(* koketeri, vu qu'on continu  ranger concetement
   les options dans des var. globales ! (cf Global
*)
type t = {
  mutable opts : (string * Arg.spec * string) list; (* classical Arg option tab used by Arg.parse *)
  mutable user_man  : (string * string list) list; (* ad hoc tab for pretty prtting usage *)
  mutable hidden_man: (string * string list) list; (* ad hoc tab for pretty prtting usage *) 
  mutable others: string list;
  mutable margin : int;
  mutable outfile :  string;
  mutable infiles :  string list;
  mutable main_node :  string;
  mutable compile_all_items : bool;
  mutable run_unit_test :  bool;
  mutable print_interface :  bool;
  mutable inline_iterator :  bool;
  mutable expand_nodes :  bool;
  mutable dont_expand_nodes :  string list;
  mutable expand_arrays :  bool;
  mutable gen_autotest :  bool;
  mutable oc :  Pervasives.out_channel;
  mutable tlex :  bool;
  mutable exec :  bool;
  mutable rif :  bool;
  mutable gen_ocaml :  bool;
  mutable precision : int option;
}

(* Those are really too boring to be functionnal (used in all over the places) *)
type global_opt = {
  mutable lv4 :  bool;
  mutable ec :  bool;
  mutable expand_enums :  enum_mode;
  mutable one_op_per_equation :  bool;
  mutable no_prefix :  bool;
  mutable nonreg_test :  bool;
  mutable current_file :  string;
  mutable line_num : int;
  mutable line_start_pos : int;
}
val paranoid : Verbose.flag 

val global_opt:global_opt

(* La ``mthode'' principale *)
val parse : string array -> t

val usage : out_channel -> t -> unit
val full_usage : out_channel -> t -> unit

val lexbuf_of_file_name : string -> Lexing.lexbuf
